﻿Imports System.Runtime.CompilerServices

Module ExtensionModul

#Region "Integer"
   <Extension()>
   Public Function MinimumInteger(ByRef Value As Integer, ByVal Min As Integer) As Integer
      If Value < Min Then Return Min Else Return Value
   End Function
   <Extension()>
   Public Function MaximumInteger(ByRef Value As Integer, ByVal Max As Integer) As Integer
      If Value > Max Then Return Max Else Return Value
   End Function
   <Extension()>
   Public Function BetweenInteger(ByRef Value As Integer, ByRef Min As Integer, ByVal Max As Integer) As Integer
      If Value >= Min AndAlso Value <= Max Then
         Return Value
      ElseIf Value < Min Then
         Return Min
      ElseIf Value > Max Then
         Return Max
      Else
         Return 0
      End If
   End Function
   <Extension()>
   Public Function ToUInteger(Value As Integer) As UInteger
      Return CType(Value, UInteger)
   End Function
   <Extension()>
   Public Function ToDecimal(Value As Integer) As Decimal
      Return CType(Value, Decimal)
   End Function
   <Extension()>
   Public Function ToDouble(Value As Integer) As Double
      Return CType(Value, Double)
   End Function
   <Extension()>
   Public Function ToSingle(Value As Integer) As Single
      Return CType(Value, Single)
   End Function
   <Extension()>
   Public Function ToSByte(Value As Integer) As SByte
      Return CType(Value, SByte)
   End Function
   <Extension()>
   Public Function ToByte(Value As Integer) As Byte
      Return CType(Value, Byte)
   End Function
   <Extension()>
   Public Function ToShort(Value As Integer) As Short
      Return CType(Value, Short)
   End Function
   <Extension()>
   Public Function ToUShort(Value As Integer) As UShort
      Return CType(Value, UShort)
   End Function
   <Extension()>
   Public Function ToLong(Value As Integer) As Long
      Return CType(Value, Long)
   End Function
   <Extension()>
   Public Function ToULong(Value As Integer) As ULong
      Return CType(Value, ULong)
   End Function
#End Region

#Region "Double"
   <Extension()>
   Public Function ToUInteger(Value As Double) As UInteger
      Return CType(Value, UInteger)
   End Function
   <Extension()>
   Public Function ToDecimal(Value As Double) As Decimal
      Return CType(Value, Decimal)
   End Function
   <Extension()>
   Public Function ToInteger(Value As Double) As Integer
      Return CType(Value, Integer)
   End Function
   <Extension()>
   Public Function ToSingle(Value As Double) As Single
      Return CType(Value, Single)
   End Function
   <Extension()>
   Public Function ToSByte(Value As Double) As SByte
      Return CType(Value, SByte)
   End Function
   <Extension()>
   Public Function ToByte(Value As Double) As Byte
      Return CType(Value, Byte)
   End Function
   <Extension()>
   Public Function ToShort(Value As Double) As Short
      Return CType(Value, Short)
   End Function
   <Extension()>
   Public Function ToUShort(Value As Double) As UShort
      Return CType(Value, UShort)
   End Function
   <Extension()>
   Public Function ToLong(Value As Double) As Long
      Return CType(Value, Long)
   End Function
   <Extension()>
   Public Function ToULong(Value As Double) As ULong
      Return CType(Value, ULong)
   End Function
#End Region

#Region "Decimal"
   <Extension()>
   Public Function ToUInteger(Value As Decimal) As UInteger
      Return CType(Value, UInteger)
   End Function
   <Extension()>
   Public Function ToDouble(Value As Decimal) As Double
      Return CType(Value, Decimal)
   End Function
   <Extension()>
   Public Function ToInteger(Value As Decimal) As Integer
      Return CType(Value, Integer)
   End Function
   <Extension()>
   Public Function ToSingle(Value As Decimal) As Single
      Return CType(Value, Single)
   End Function
   <Extension()>
   Public Function ToSByte(Value As Decimal) As SByte
      Return CType(Value, SByte)
   End Function
   <Extension()>
   Public Function ToByte(Value As Decimal) As Byte
      Return CType(Value, Byte)
   End Function
   <Extension()>
   Public Function ToShort(Value As Decimal) As Short
      Return CType(Value, Short)
   End Function
   <Extension()>
   Public Function ToUShort(Value As Decimal) As UShort
      Return CType(Value, UShort)
   End Function
   <Extension()>
   Public Function ToLong(Value As Decimal) As Long
      Return CType(Value, Long)
   End Function
   <Extension()>
   Public Function ToULong(Value As Decimal) As ULong
      Return CType(Value, ULong)
   End Function
#End Region

#Region "String"
   <Extension()>
   Public Function ToInteger(Value As String) As Integer
      Dim num As Integer
      If Not Integer.TryParse(Value, num) Then
         num = -1
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToUInteger(Value As String) As UInteger
      Dim num As UInteger
      If Not UInteger.TryParse(Value, num) Then
         num = 0
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToDecimal(Value As String) As Decimal
      Dim num As Decimal
      If Not Decimal.TryParse(Value, num) Then
         num = -1
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToDouble(Value As String) As Double
      Dim num As Double
      If Not Double.TryParse(Value, num) Then
         num = -1
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToSingle(Value As String) As Single
      Dim num As Single
      If Not Single.TryParse(Value, num) Then
         num = -1
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToSByte(Value As String) As SByte
      Dim num As SByte
      If Not SByte.TryParse(Value, num) Then
         num = -1
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToByte(Value As String) As Byte
      Dim num As Byte
      If Not Byte.TryParse(Value, num) Then
         num = 0
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToShort(Value As String) As Short
      Dim num As Short
      If Not Short.TryParse(Value, num) Then
         num = -1
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToUShort(Value As String) As UShort
      Dim num As UShort
      If Not UShort.TryParse(Value, num) Then
         num = 0
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToLong(Value As String) As Long
      Dim num As Long
      If Not Long.TryParse(Value, num) Then
         num = -1
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToULong(Value As String) As ULong
      Dim num As ULong
      If Not ULong.TryParse(Value, num) Then
         num = 0
      End If
      Return num
   End Function
   <Extension()>
   Public Function ToChar(Value As String) As Char
      Dim cha As Char
      If Not Char.TryParse(Value, cha) Then
         cha = " "c
      End If
      Return cha
   End Function
#End Region
End Module